package com.biganto.visual.roompark.data.repository.api.retrofit

import io.reactivex.Observable
import retrofit2.Response
import retrofit2.http.GET
import retrofit2.http.Query


/**
 * Created by Vladislav Bogdashkin on 13.06.2018.
 */





interface IRoomParkMobileApi{

    companion object{
//        const val BASE_URL="https://stage.room-park.ru:38386"
        const val BASE_URL="https://room-park.ru"
        //const val API_URL="api-novus/"
        const val API_URL="api/"
        const val DELIMITER="?"
        const val CLIENT_TYPE_PARAM="client"
        const val CLIENT_VERSION_PARAM="client_version"
        const val API_VERSION_PARAM="v"
        const val AUTH_TOKEN="auth_token"

        const val LANG_PARAM="lang"
        const val DEFAULT_LANG_VALUE="en"

        const val DEFAULT_CLIENT_TYPE="androidplayer"
        //const val DEFAULT_CLIENT_TYPE="iosplayer"
        const val OLD_CLIENT_TYPE="mobileplayer"

        const val DEFAULT_CLIENT_VERSION="3.0"
        const val DEFAULT_API_VERSION="2.0"

        //region AppInfo
        const val GET_APP_VERSION="misc.appVersion"
//endregion

        //region GetEstates
        const val GET_ZONES_METHOD="vr.getZones"
//endregion

//region GetToursOverview
        const val GET_TOURS_METHOD="vr.getTours"//"tours.getList"
        //const val PARENT_ESTATE_PARAM="id"
        const val PARENT_ZONE_PARAM="zone"
//endregion

    }


    @GET("$API_URL$GET_ZONES_METHOD$DELIMITER")
    fun authoriz(
        @Query(CLIENT_TYPE_PARAM) clientType: String = DEFAULT_CLIENT_TYPE,
        @Query(CLIENT_VERSION_PARAM) clientVersion: String = DEFAULT_CLIENT_VERSION,
        @Query(API_VERSION_PARAM) apiVersion: String = DEFAULT_API_VERSION
    ): Observable<Response<String>>

    @GET("$API_URL$GET_TOURS_METHOD$DELIMITER")
    fun getToursPreviewById(
        @Query(CLIENT_TYPE_PARAM) clientType: String = DEFAULT_CLIENT_TYPE,
        @Query(CLIENT_VERSION_PARAM) clientVersion: String = DEFAULT_CLIENT_VERSION,
        @Query(API_VERSION_PARAM) apiVersion: String = DEFAULT_API_VERSION,
        @Query(PARENT_ZONE_PARAM) id: String
    ): Observable<Response<String>>


}